diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/census_document.cpp lmi-editor/census_document.cpp
--- cvs/census_document.cpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/census_document.cpp	2008-01-30 21:04:27.000000000 +0100
@@ -94,19 +94,12 @@
     return true;
 }
 
-bool CensusDocument::OnOpenDocument(wxString const& filename)
+bool CensusDocument::DoOpenDocument(wxString const& filename)
 {
-    SetFilename(filename, true);
-    // WX !! This necessary function is undocumented. It must be
-    // called here; otherwise, wxView::OnSave() pops up an annoying
-    // 'Save As' dialog downstream when the file loaded here is saved.
-    SetDocumentSaved();
-//    Modify(false); // TODO ?? Is this merely pleonastic?
-    UpdateAllViews();
     return true;
 }
 
-bool CensusDocument::OnSaveDocument(wxString const& filename)
+bool CensusDocument::DoSaveDocument(wxString const& filename)
 {
     convert_to_ihs(doc_.case_parms_ , case_parms_ );
     convert_to_ihs(doc_.cell_parms_ , cell_parms_ );
@@ -115,7 +108,6 @@
     std::ofstream ofs(filename.c_str());
     doc_.write(ofs);
 
-    Modify(false);
     status() << "Document saved." << std::flush;
     return true;
 }
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/census_document.hpp lmi-editor/census_document.hpp
--- cvs/census_document.hpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/census_document.hpp	2008-01-30 21:04:27.000000000 +0100
@@ -21,7 +21,7 @@
 
 // $Id: census_document.hpp,v 1.7 2008/01/01 18:29:36 chicares Exp $
 
-// WX !! Override OnOpenDocument() and OnSaveDocument() instead of
+// WX !! Override DoOpenDocument() and DoSaveDocument() instead of
 // LoadObject() and SaveObject(): the latter would probably work, but
 // their diagnostic messages aren't customizable.
 
@@ -59,8 +59,8 @@
     // wxDocument overrides.
     virtual bool OnCreate(wxString const& filename, long int flags);
     virtual bool OnNewDocument();
-    virtual bool OnOpenDocument(wxString const& filename);
-    virtual bool OnSaveDocument(wxString const& filename);
+    virtual bool DoOpenDocument(wxString const& filename);
+    virtual bool DoSaveDocument(wxString const& filename);
 
     multiple_cell_document doc_;
 
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/census_view.cpp lmi-editor/census_view.cpp
--- cvs/census_view.cpp	2008-02-02 12:23:07.000000000 +0100
+++ lmi-editor/census_view.cpp	2008-01-30 21:04:27.000000000 +0100
@@ -51,6 +51,8 @@
 #include <wx/listctrl.h>
 #include <wx/menu.h>
 #include <wx/msgdlg.h>
+#include <wx/utils.h>   // wxBusyCursor
+#include <wx/wupdlock.h>
 #include <wx/xrc/xmlres.h>
 
 #include <algorithm>
@@ -84,6 +86,20 @@
     }
 }
 
+// Protect CensusView list window frame from updates
+// until this 'locker' object is destroyed. The instances of this class
+// are meant to be created on stack so that the guarded widget
+// is unfrozen automatically once the scope is left.
+class census_view_update_locker
+    :public wxWindowUpdateLocker
+{
+  public:
+    census_view_update_locker(CensusView const& census_view)
+        :wxWindowUpdateLocker(census_view.list_window_)
+    {
+    }
+};
+
 IMPLEMENT_DYNAMIC_CLASS(CensusView, ViewEx)
 
 BEGIN_EVENT_TABLE(CensusView, ViewEx)
@@ -330,15 +346,6 @@
     return rc;
 }
 
-// TODO ?? Implement this optimization. Instead of simply calling
-// Freeze() and Thaw() on the list view, consider a class that
-// freezes when created on the stack and thaws when it goes out of
-// scope, to guard against exceptions.
-void CensusView::freeze(bool)
-{
-    return;
-}
-
 bool CensusView::is_invalid()
 {
     if(!all_changes_have_been_validated_)
@@ -465,14 +472,15 @@
     std::copy(rebuilt_class_parms.begin(), rebuilt_class_parms.end(), iip);
 }
 
-// TODO ?? Lowercase this. Why does it freeze() a GUI that it doesn't touch?
+// TODO ?? Lowercase this. Why does it protects from updates a GUI
+// that it doesn't touch?
 void CensusView::ApplyChanges
     (Input const& new_parms
     ,Input const& old_parms
     ,bool         for_this_class_only
     )
 {
-    freeze(true);
+    census_view_update_locker no_updates(*this);
 
     // Case or class default parameters were edited and changed.
     // Compare the default parameters before and after editing;
@@ -542,7 +550,6 @@
         }
 
     composite_is_available_ = false;
-    freeze(false);
 }
 
 void CensusView::DisplayAllVaryingData()
@@ -699,28 +706,25 @@
 //
 void CensusView::UponColumnWidthVarying(wxCommandEvent&)
 {
-    freeze(true);
+    census_view_update_locker no_updates(*this);
     for(int j = 0; j < list_window_->GetColumnCount(); ++j)
         {
 // TODO ?? Pick one, and remove the other?
 //        list_window_->SetColumnWidth(j, wxLIST_AUTOSIZE);
         list_window_->SetColumnWidth(j, wxLIST_AUTOSIZE_USEHEADER);
         }
-
-    freeze(false);
 }
 
 // Shrink all nonfrozen columns to default width.
 void CensusView::UponColumnWidthFixed(wxCommandEvent&)
 {
-    freeze(true);
+    census_view_update_locker no_updates(*this);
     for(int j = 0; j < list_window_->GetColumnCount(); ++j)
         {
         // WX !! Sad to hardcode '80', but that's the undocumented wx default.
         // TODO ?? If it's a default, then why must it be specified?
         list_window_->SetColumnWidth(j, 80);
         }
-    freeze(false);
 }
 
 // TODO ?? Right-click handlers: pick one approach, and remove failed experiments.
@@ -798,7 +802,7 @@
 //  if a new one comes into use, display it.
 void CensusView::Update()
 {
-    freeze(true);
+    census_view_update_locker no_updates(*this);
 
     list_window_->ClearAll();
 
@@ -808,13 +812,11 @@
 
     // All displayed data is valid when this function ends.
     all_changes_have_been_validated_ = true;
-
-    freeze(false);
 }
 
 void CensusView::UpdatePreservingSelection()
 {
-    freeze(true);
+    census_view_update_locker no_updates(*this);
 
     // Save active cell.
     int selection = selected_row();
@@ -836,7 +838,6 @@
     list_window_->EnsureVisible(top_row);
     list_window_->EnsureVisible(selection);
 
-    freeze(false);
 }
 
 void CensusView::UponPrintCell(wxCommandEvent&)
@@ -848,13 +849,11 @@
         }
 
     int cell_number = selected_row();
-    freeze(true);
+    census_view_update_locker no_updates(*this);
     // TODO ?? Is it desirable to create a view here, or would it be
     // better to print invisibly? If the latter, then probably
     // ViewOneCell() could be simplified to return void.
     ViewOneCell(cell_number).Pdf("print");
-
-    freeze(false);
 }
 
 void CensusView::UponPrintCase(wxCommandEvent&)
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/census_view.hpp lmi-editor/census_view.hpp
--- cvs/census_view.hpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/census_view.hpp	2008-01-30 21:04:27.000000000 +0100
@@ -133,8 +133,6 @@
         ,std::string const& name
         );
 
-    void freeze(bool);
-
     void identify_varying_columns();
 
     bool is_invalid();
@@ -154,6 +152,7 @@
 
     bool was_cancelled_;
 
+    friend class census_view_update_locker; // for list_window_ access
     wxListView* list_window_;
 
     DECLARE_DYNAMIC_CLASS(CensusView)
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/database_document.cpp lmi-editor/database_document.cpp
--- cvs/database_document.cpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/database_document.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -90,12 +90,14 @@
 {
 }
 
-TDBValue* DatabaseDocument::GetTDBValue(std::size_t index)
+TDBValue& DatabaseDocument::GetTDBValue(DatabaseNames index)
 {
     if(dict_.find(index) == dict_.end())
-        {fatal_error() << "Index out of bounds." << LMI_FLUSH;}
+        {
+        fatal_error() << "Index out of bounds." << LMI_FLUSH;
+        }
 
-    return &dict_[index];
+    return dict_[index];
 }
 
 void DatabaseDocument::ReadDocument(std::string const& filename)
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/database_document.hpp lmi-editor/database_document.hpp
--- cvs/database_document.hpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/database_document.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -26,10 +26,11 @@
 
 #include "config.hpp"
 
+#include "dbnames.hpp"
+#include "ihs_dbdict.hpp"
 #include "product_editor.hpp"
 
-#include "ihs_dbvalue.hpp"
-#include "ihs_dbdict.hpp"
+class LMI_SO TDBValue;
 
 class DatabaseDocument
     :public ProductEditorDocument
@@ -38,7 +39,7 @@
     DatabaseDocument();
     virtual ~DatabaseDocument();
 
-    TDBValue* GetTDBValue(std::size_t index);
+    TDBValue& GetTDBValue(DatabaseNames index);
 
   private:
     // ProductEditorDocument overrides.
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/database_view.cpp lmi-editor/database_view.cpp
--- cvs/database_view.cpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/database_view.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -38,6 +38,7 @@
 #include "wx_new.hpp"
 
 #include <wx/icon.h>
+#include <wx/sizer.h>
 #include <wx/treectrl.h>
 #include <wx/window.h>
 
@@ -111,34 +112,35 @@
   :public wxTreeItemData
 {
   public:
-    database_tree_item_data(std::size_t id, std::string const& description);
+    database_tree_item_data(db_names const&);
+    virtual ~database_tree_item_data() {}
 
-    std::size_t id() const;
-    std::string const& description() const;
+    db_names const& db_name() const {return db_names_;}
+
+    std::pair<int,int> get_axes_selected() const;
+    void set_axes_selected(std::pair<int,int> const&);
 
   private:
-    std::size_t id_;
-    std::string description_;
+    db_names const& db_names_;
+    std::pair<int,int> axes_selected_;
 };
 
-database_tree_item_data::database_tree_item_data
-    (std::size_t id
-    ,std::string const& description
-    )
-    :wxTreeItemData()
-    ,id_(id)
-    ,description_(description)
+database_tree_item_data::database_tree_item_data(db_names const& names)
+    :db_names_(names)
+    ,axes_selected_(wxNOT_FOUND, wxNOT_FOUND)
 {
 }
 
-std::size_t database_tree_item_data::id() const
+std::pair<int,int> database_tree_item_data::get_axes_selected() const
 {
-    return id_;
+    return axes_selected_;
 }
 
-std::string const& database_tree_item_data::description() const
+void database_tree_item_data::set_axes_selected
+    (std::pair<int,int> const& axes_selected
+    )
 {
-    return description_;
+    axes_selected_ = axes_selected;
 }
 
 } // Unnamed namespace.
@@ -159,13 +161,10 @@
 {
 }
 
-// EVGENIY !! Here and anywhere else 'wxWindow* panel' occurs,
-// does the name 'panel' suggest that the type should be wxPanel?
-
-wxTreeCtrl* DatabaseView::CreateTreeCtrl(wxWindow* panel)
+wxTreeCtrl* DatabaseView::CreateTreeCtrl(wxWindow* parent)
 {
     return new(wx) AutoResizingTreeCtrl
-        (panel
+        (parent
         ,wxID_ANY
         ,wxDefaultPosition
         ,wxDefaultSize
@@ -173,10 +172,10 @@
         );
 }
 
-MultiDimGrid* DatabaseView::CreateGridCtrl(wxWindow* panel)
+MultiDimGrid* DatabaseView::CreateGridCtrl(wxWindow* parent)
 {
     LMI_ASSERT(table_adapter_);
-    return new(wx) DatabaseEditorGrid(panel, table_adapter_);
+    return new(wx) DatabaseEditorGrid(parent, table_adapter_);
 }
 
 void DatabaseView::SetupControls()
@@ -184,7 +183,7 @@
     std::vector<db_names> const& names = GetDBNames();
     std::map<DatabaseNames, wxTreeItemId> name_to_id;
 
-    wxTreeCtrl& tree = GetTreeCtrl();
+    wxTreeCtrl& tree_ctrl = tree();
 
     for(std::size_t i = 0; i < names.size(); ++i)
         {
@@ -192,11 +191,11 @@
         if(0 == i)
             {
             LMI_ASSERT(name.Idx == name.ParentIdx);
-            wxTreeItemId id = tree.AddRoot
+            wxTreeItemId id = tree_ctrl.AddRoot
                 (""
                 ,-1
                 ,-1
-                ,new(wx) database_tree_item_data(i, name.LongName)
+                ,new(wx) database_tree_item_data(name)
                 );
             name_to_id[name.Idx] = id;
             }
@@ -204,19 +203,19 @@
             {
             LMI_ASSERT(name.Idx != name.ParentIdx);
             wxTreeItemId parent = name_to_id[name.ParentIdx];
-            wxTreeItemId id = tree.AppendItem
+            wxTreeItemId id = tree_ctrl.AppendItem
                 (parent
                 ,name.ShortName
                 ,-1
                 ,-1
-                ,new(wx) database_tree_item_data(i, name.LongName)
+                ,new(wx) database_tree_item_data(name)
                 );
             name_to_id[name.Idx] = id;
             }
         }
 
     // Force BestSize to be recalculated, since we have added new items
-    tree.InvalidateBestSize();
+    tree_ctrl.InvalidateBestSize();
 }
 
 wxIcon DatabaseView::Icon() const
@@ -259,23 +258,44 @@
 
 void DatabaseView::UponTreeSelectionChange(wxTreeEvent& event)
 {
-    wxTreeCtrl& tree = GetTreeCtrl();
-    database_tree_item_data* item_data = dynamic_cast<database_tree_item_data*>
-        (tree.GetItemData(event.GetItem())
-        );
-    if(!item_data)
-        {return;}
+    wxTreeCtrl& tree_ctrl = tree();
+    MultiDimGrid& grid_ctrl = grid();
 
-    std::size_t index = item_data->id();
+    // save the current selection
+    wxTreeItemId const old_item = event.GetOldItem();
+    if(old_item.IsOk())
+        {
+        database_tree_item_data* old_item_data =
+            dynamic_cast<database_tree_item_data*>
+                (tree_ctrl.GetItemData(old_item)
+                );
+        if(old_item_data)
+            {
+            old_item_data->set_axes_selected(grid_ctrl.GetGridAxisSelection());
+            }
+        }
 
-    table_adapter().SetTDBValue(document().GetTDBValue(index));
+    database_tree_item_data* item_data =
+        dynamic_cast<database_tree_item_data*>
+            (tree_ctrl.GetItemData(event.GetItem())
+            );
+    if(!item_data)
+        {return;}
 
-    bool is_topic = tree.GetChildrenCount(event.GetItem());
+    table_adapter().SetTDBValue
+        (&document().GetTDBValue(item_data->db_name().Idx)
+        );
 
-    SetLabel(item_data->description());
+    bool is_topic = tree_ctrl.GetChildrenCount(event.GetItem());
 
-    MultiDimGrid& grid = GetGridCtrl();
+    set_grid_label_text(item_data->db_name().LongName);
 
-    grid.Enable(!is_topic);
-    grid.RefreshTableFull();
+    wxSizer* sizer = grid_ctrl.GetContainingSizer();
+    LMI_ASSERT(sizer);
+    sizer->Show(&grid_ctrl, !is_topic);
+    sizer->Layout();
+
+    // restore axis selection if any
+    grid_ctrl.SetGridAxisSelection(item_data->get_axes_selected());
+    grid_ctrl.RefreshTableFull();
 }
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/database_view_editor.cpp lmi-editor/database_view_editor.cpp
--- cvs/database_view_editor.cpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/database_view_editor.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -27,9 +27,6 @@
 #include "multidimgrid_safe.tpp"
 #include "value_cast.hpp"
 
-#include <boost/preprocessor/cat.hpp>
-#include <boost/preprocessor/repetition/repeat_from_to.hpp>
-
 #include <wx/msgdlg.h>
 #include <wx/utils.h> // wxBusyCursor
 
@@ -40,6 +37,7 @@
     :db_value_(db_value)
     ,modified_(false)
 {
+    indexes_.resize(eda_max);
 }
 
 DatabaseTableAdapter::~DatabaseTableAdapter()
@@ -112,10 +110,12 @@
 /// Require confirmation if reshaping an entity would cause it to have
 /// extraordinarily many elements.
 
-bool DatabaseTableAdapter::ConfirmOperation(unsigned int item_count) const
+bool DatabaseTableAdapter::ConfirmOperation(int item_count) const
 {
     if(item_count < 1000000)
-        {return true;}
+        {
+        return true;
+        }
 
     std::string const message =
         "The resulting entity will have more than one million elements."
@@ -159,9 +159,7 @@
     ,bool user_confirm
     )
 {
-// EVGENIY !! Why use 'std::size_t' here? It can't actually prevent
-// std::accumulate() from overflowing MAX_INT, can it?
-    std::size_t count = std::accumulate
+    int count = std::accumulate
         (axis_lengths.begin()
         ,axis_lengths.end()
         ,1
@@ -170,9 +168,7 @@
 
     if(!user_confirm || ConfirmOperation(count))
         {
-// EVGENIY !! I don't actually see an hourglass cursor. Is this an
-// object-lifetime problem?
-        wxBusyCursor();
+        wxBusyCursor busy;
 
         db_value_->Reshape(axis_lengths);
         SetModified();
@@ -195,45 +191,27 @@
     return n < db_value_->GetAxisLengths().size();
 }
 
-std::string DatabaseTableAdapter::ValueToString(boost::any const& value) const
-{
-    try
-        {
-        return value_cast<std::string>(boost::any_cast<double>(value));
-        }
-    catch(std::exception const&)
-        {
-        // TODO ?? Would a different behavior be better here?
-        return "#ERR";
-        }
-}
-
-boost::any DatabaseTableAdapter::StringToValue(std::string const& value) const
-{
-    double z = 0.0;
-    try
-        {
-        z = value_cast<double>(value);
-        }
-    catch(std::exception const&)
-        {
-        // TODO ?? What should we do here?
-        }
-    return boost::any(z);
-}
-
 void DatabaseTableAdapter::ConvertValue
     (Coords const& coords
     ,std::vector<int>& indexes
-    ) const
+    )
 {
-    #define CAST_BOOST_ANY_TO_INT_(z, n, unused) \
-    indexes[n] = boost::any_cast<BOOST_PP_CAT(AxisValueType,n)>(coords[n]);
-
-    BOOST_STATIC_ASSERT(DatabaseTableAdapter::eda_max == 7);
-    BOOST_PP_REPEAT_FROM_TO(0, 7, CAST_BOOST_ANY_TO_INT_, ~)
+    indexes[eda_gender]    = UnwrapAny<enum_gender>  (coords[eda_gender]);
+    indexes[eda_class]     = UnwrapAny<enum_class>   (coords[eda_class]);
+    indexes[eda_smoking]   = UnwrapAny<enum_smoking> (coords[eda_smoking]);
+    indexes[eda_issue_age] = UnwrapAny<int>          (coords[eda_issue_age]);
+    indexes[eda_uw_basis]  = UnwrapAny<enum_uw_basis>(coords[eda_uw_basis]);
+    indexes[eda_state]     = UnwrapAny<enum_state>   (coords[eda_state]);
+    indexes[eda_duration]  = UnwrapAny<int>          (coords[eda_duration]);
+    // If the following assert fails, then it probably means that
+    // the number of axes has been changed and the change should
+    // be reflected in the code above.
+    BOOST_STATIC_ASSERT( eda_max == 7 );
+}
 
-    #undef CAST_BOOST_ANY_TO_INT_
+unsigned int DatabaseTableAdapter::DoGetDimension() const
+{
+    return eda_max;
 }
 
 bool DatabaseTableAdapter::IsVoid() const
@@ -241,100 +219,45 @@
     return db_value_ == NULL;
 }
 
-boost::any DatabaseTableAdapter::DoGetValue(Coords const& coords) const
+double DatabaseTableAdapter::DoGetValue(Coords const& coords) const
 {
     if(IsVoid())
-        {return boost::any(static_cast<double>(0));}
+        {
+        return 0;
+        }
 
-    indexes_.clear();
-    indexes_.resize(coords.size());
     ConvertValue(coords, indexes_);
 
-    double val = db_value_->operator[](indexes_);
-    return boost::any(val);
+    return (*db_value_)[indexes_];
 }
 
 void DatabaseTableAdapter::DoSetValue
     (Coords const& coords
-    ,boost::any const& value
+    ,double const& value
     )
 {
     if(IsVoid())
         {return;}
 
-    indexes_.clear();
-    indexes_.resize(coords.size());
     ConvertValue(coords, indexes_);
 
-    double double_value = boost::any_cast<double>(value);
-    db_value_->operator[](indexes_) = double_value;
+    (*db_value_)[indexes_] = value;
     SetModified();
 }
 
-/// The two methods below are not used but still have to be implemented.
-/// The reason for that wierdness is the fact that we are showing
-/// pairs of doubles as two columns of doubles and not as a single column
-/// (which is the default implementation). Therefore we trick MDGrid and
-/// MDGridTable and interface them in such a way, that these two
-/// pure virtual methods are not used at all, hense an implementation still
-/// has to provided (in this case an empty one, since functions are not used).
-double DatabaseTableAdapter::GetValue
-    (enum_gender
-    ,enum_class
-    ,enum_smoking
-    ,int
-    ,enum_uw_basis
-    ,enum_state
-    ,int
-    ) const
-{
-    return 0;
-}
-void DatabaseTableAdapter::SetValue
-    (enum_gender
-    ,enum_class
-    ,enum_smoking
-    ,int
-    ,enum_uw_basis
-    ,enum_state
-    ,int
-    ,double const&
-    )
-{
-}
-
-MultiDimAxis<enum_gender>* DatabaseTableAdapter::GetAxis0()
-{
-    return new DatabaseGenderAxis();
-}
-
-MultiDimAxis<enum_class>* DatabaseTableAdapter::GetAxis1()
-{
-    return new DatabaseClassAxis();
-}
-
-MultiDimAxis<enum_smoking>* DatabaseTableAdapter::GetAxis2()
+MultiDimTableAny::AxesAny DatabaseTableAdapter::DoGetAxesAny()
 {
-    return new DatabaseSmokingAxis();
+    AxesAny axes(eda_max);
+    axes[eda_gender]    = AxisAnyPtr(new DatabaseGenderAxis());
+    axes[eda_class]     = AxisAnyPtr(new DatabaseClassAxis());
+    axes[eda_smoking]   = AxisAnyPtr(new DatabaseSmokingAxis());
+    axes[eda_issue_age] = AxisAnyPtr(new DatabaseIssueAgeAxis());
+    axes[eda_uw_basis]  = AxisAnyPtr(new DatabaseUwBasisAxis());
+    axes[eda_state]     = AxisAnyPtr(new DatabaseStateAxis());
+    axes[eda_duration]  = AxisAnyPtr(new DatabaseDurationAxis());
+    // If the following assert fails, then it probably means that
+    // the number of axes has been changed and the change should
+    // be reflected in the code above.
+    BOOST_STATIC_ASSERT( eda_max == 7 );
+    return axes;
 }
-
-MultiDimAxis<int>* DatabaseTableAdapter::GetAxis3()
-{
-    return new DatabaseIssueAgeAxis();
-}
-
-MultiDimAxis<enum_uw_basis>* DatabaseTableAdapter::GetAxis4()
-{
-    return new DatabaseUwBasisAxis();
-}
-
-MultiDimAxis<enum_state>* DatabaseTableAdapter::GetAxis5()
-{
-    return new DatabaseStateAxis();
-}
-
-MultiDimAxis<int>* DatabaseTableAdapter::GetAxis6()
-{
-    return new DatabaseDurationAxis();
-}
-
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/database_view_editor.hpp lmi-editor/database_view_editor.hpp
--- cvs/database_view_editor.hpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/database_view_editor.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -114,19 +114,6 @@
     {}
 };
 
-/// Base type for the Database files editing control underlying data table
-typedef MultiDimTable7
-    <double
-    ,enum_gender
-    ,enum_class
-    ,enum_smoking
-    ,int
-    ,enum_uw_basis
-    ,enum_state
-    ,int
-    >
-DatabaseTableAdapterBase;
-
 /// Database dictionary adapter for TDBValue class
 ///
 /// One could mention Adaptor pattern.
@@ -137,7 +124,7 @@
 /// boost::shared_ptr constructed with deallocator object that does nothing.
 
 class DatabaseTableAdapter
-  :public DatabaseTableAdapterBase
+  :public MultiDimTable<double, DatabaseTableAdapter>
 {
     enum enum_database_axis
         {eda_gender = 0
@@ -149,7 +136,11 @@
         ,eda_duration
         ,eda_max
         };
-
+    BOOST_STATIC_ASSERT
+        (
+           static_cast<int>(DatabaseTableAdapter::eda_max)
+        == static_cast<int>(TDBValue::e_number_of_axes)
+        );
   public:
     DatabaseTableAdapter(TDBValue* db_value = NULL);
 
@@ -166,62 +157,27 @@
     void SetDurationMaxBound(unsigned int n);
     unsigned int GetDurationMaxBound() const;
 
+    // MultiDimGridN contract.
+    double DoGetValue(Coords const&) const;
+    void DoSetValue(Coords const&, double const&);
+
   private:
-// EVGENIY !! Does pure virtual MultiDimTableAny::DoGetAxisAny() need
-// to be implemented here?
     /// MultiDimTableAny required implementation.
-    virtual boost::any DoGetValue(Coords const&) const;
-    virtual void DoSetValue(Coords const&, boost::any const&);
-    virtual bool DoApplyAxisAdjustment(MultiDimAxisAny&, unsigned int);
-    virtual bool DoRefreshAxisAdjustment(MultiDimAxisAny&, unsigned int);
-
-// EVGENIY !! Should this say 'MultiDimTableAny' instead of 'MultiDimTable'?
-    /// MultiDimTable overrides.
     virtual bool VariesByDimension(unsigned int) const;
     virtual void MakeVaryByDimension(unsigned int, bool);
     virtual bool CanChangeVariationWith(unsigned int) const;
-    virtual std::string ValueToString(boost::any const&) const;
-    virtual boost::any StringToValue(std::string const&) const;
+    AxesAny DoGetAxesAny();
+    virtual unsigned int DoGetDimension() const;
 
-// EVGENIY !! I think these functions override a macro class; how
-// we document that depends on the patch you're working on.
-    virtual MultiDimAxis<enum_gender>*   GetAxis0();
-    virtual MultiDimAxis<enum_class>*    GetAxis1();
-    virtual MultiDimAxis<enum_smoking>*  GetAxis2();
-    virtual MultiDimAxis<int>*           GetAxis3();
-    virtual MultiDimAxis<enum_uw_basis>* GetAxis4();
-    virtual MultiDimAxis<enum_state>*    GetAxis5();
-    virtual MultiDimAxis<int>*           GetAxis6();
-
-    // not used but has to be implemented
-    virtual double GetValue
-        (enum_gender
-        ,enum_class
-        ,enum_smoking
-        ,int
-        ,enum_uw_basis
-        ,enum_state
-        ,int
-        ) const;
-    virtual void SetValue
-        (enum_gender
-        ,enum_class
-        ,enum_smoking
-        ,int
-        ,enum_uw_basis
-        ,enum_state
-        ,int
-        ,double const&
-        );
+    /// MultiDimTableAny overrides.
+    virtual bool DoApplyAxisAdjustment(MultiDimAxisAny&, unsigned int);
+    virtual bool DoRefreshAxisAdjustment(MultiDimAxisAny&, unsigned int);
 
     /// Helper, converts array of boost::any into array of ints
-    void ConvertValue
-        (Coords const&
-        ,std::vector<int>&
-        ) const;
+    static void ConvertValue(Coords const&, std::vector<int>&);
 
     bool IsVoid() const;
-    bool ConfirmOperation(unsigned int itemCount) const;
+    bool ConfirmOperation(int itemCount) const;
     void ReshapeTableData
         (std::vector<int>& axis_lengths
         ,bool user_confirm = false
@@ -266,16 +222,6 @@
 class DatabaseEditorGrid
   :public MultiDimGrid
 {
-#if 0
-// EVGENIY--This fails with gcc-4.x because 'eda_max' is private.
-// Perhaps we should move it to some other place where it's valid.
-    BOOST_STATIC_ASSERT
-        (
-           static_cast<int>(TDBValue::e_number_of_axes)
-        == static_cast<int>(DatabaseTableAdapter::eda_max)
-        );
-#endif // 0
-
   public:
     DatabaseEditorGrid
         (wxWindow*
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/illustration_document.cpp lmi-editor/illustration_document.cpp
--- cvs/illustration_document.cpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/illustration_document.cpp	2008-01-30 21:04:28.000000000 +0100
@@ -146,18 +146,12 @@
 // function would clear the 'modified' flag, which would be incorrect
 // here.
 //
-bool IllustrationDocument::OnOpenDocument(wxString const& filename)
+bool IllustrationDocument::DoOpenDocument(wxString const& filename)
 {
-    SetFilename(filename, true);
-    // WX !! This necessary function is undocumented. It must be
-    // called here; otherwise, wxView::OnSave() pops up an annoying
-    // 'Save As' dialog downstream when the file loaded here is saved.
-    SetDocumentSaved();
-    UpdateAllViews();
     return true;
 }
 
-bool IllustrationDocument::OnSaveDocument(wxString const& filename)
+bool IllustrationDocument::DoSaveDocument(wxString const& filename)
 {
     if(is_phony_)
         {
@@ -168,8 +162,6 @@
     convert_to_ihs(*doc_.input_data_, input_);
     std::ofstream ofs(filename.c_str());
     doc_.write(ofs);
-    Modify(false);
     status() << "Document saved." << std::flush;
     return true;
 }
-
diff -ruN -x config.h.in -x missing -x depcomp -x install-sh -x config.guess -x config.sub -x configure -x 'aclocal*' -x Makefile.in -x ltmain.sh -x 'BUILD*' -x 'autom4te*' -x CVS -x'.#*' -x'.hg*' cvs/illustration_document.hpp lmi-editor/illustration_document.hpp
--- cvs/illustration_document.hpp	2008-01-10 18:31:46.000000000 +0100
+++ lmi-editor/illustration_document.hpp	2008-01-30 21:04:28.000000000 +0100
@@ -22,7 +22,7 @@
 // $Id: illustration_document.hpp,v 1.9 2008/01/01 18:29:44 chicares Exp $
 
 // Because illustration windows have their own functions for loading
-// and saving files, override OnOpenDocument() and OnSaveDocument()
+// and saving files, override DoOpenDocument() and DoSaveDocument()
 // instead of LoadObject() and SaveObject().
 
 #ifndef illustration_document_hpp
@@ -72,8 +72,8 @@
     // wxDocument overrides.
     virtual bool OnCreate(wxString const& filename, long int flags);
     virtual bool OnNewDocument();
-    virtual bool OnOpenDocument(wxString const& filename);
-    virtual bool OnSaveDocument(wxString const& filename);
+    virtual bool DoOpenDocument(wxString const& filename);
+    virtual bool DoSaveDocument(wxString const& filename);
 
     // TODO ?? Consider using smart pointers, and forward-declaring
     // classes single_cell_document and Input.
